力扣刷题笔记 167. 两数之和 II - 输入有序数组 C#

该博客介绍了如何解决力扣(LeetCode)上的167题,即在已排序的数组中寻找两个数,使它们的和等于目标值。通过双指针法,从数组头尾开始比较,根据和与目标值的关系调整指针位置,最终找到符合条件的下标。博主提供了C#代码实现,并分析了时间复杂度为O(N),空间复杂度为O(1)。
摘要由CSDN通过智能技术生成

今日签到题,题目如下:

给定一个已按照升序排列 的有序数组,找到两个数使得它们相加之和等于目标数。

函数应该返回这两个下标值 index1 和 index2,其中 index1 必须小于 index2。

说明:

返回的下标值(index1 和 index2)不是从零开始的。
你可以假设每个输入只对应唯一的答案,而且你不可以重复使用相同的元素。
示例:

输入: numbers = [2, 7, 11, 15], target = 9
输出: [1,2]
解释: 2 与 7 之和等于目标数 9 。因此 index1 = 1, index2 = 2 。

来源:力扣(LeetCode)
链接:https://leetcode-cn.com/problems/two-sum-ii-input-array-is-sorted
著作权归领扣网络所有。商业转载请联系官方授权,非商业转载请注明出处。

很容易想到双指针,index1 放在头部,index2 放在尾部。由于数组为有序数组,如果 numbers[index1] + numbers[index2] > target,则 index2 向左移动一位。反之,则 index2 向右移动一位。如果 numbers[index1] + numbers[index2] == target,那么当前 index1,index2 即为满足题意的解,返回这两个值对应的数组。如果 index1 >= index2 则遍历完所有情况,即没有结果。

复杂度分析:

最多需要遍历整个 numbers 数组,时间复杂度为 O(N)。

没有使用额外的空间,空间复杂度为 O(1)。

以下为自己提交的代码:

public class Solution {
    public int[] TwoSum(int[] numbers, int target) {
        if (numbers.Length <= 0)
        {
            return new int[]{};
        }
        int index1 = 0;
        int index2 = numbers.Length - 1;
        int sum = numbers[index1] + numbers[index2];
        while (index1 < index2)
        {
            if (sum == target)
            {
                return new int[]{index1+1,index2+1};
            }
            else if (sum > target)
            {
                index2--;
            }
            else if (sum < target)
            {
                index1++;
            }
            sum = numbers[index1] + numbers[index2];
        }
        return new int[]{};
    }
}

解完看官方题解,还有使用二分查找,时间复杂度显然不如双指针,故不作过多记录。

评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值